<?php

namespace DestinyElements;

use function Breakdance\Elements\c;
use function Breakdance\Elements\PresetSections\getPresetSection;


\Breakdance\ElementStudio\registerElementForEditing(
    "DestinyElements\\DateUpdated",
    \Breakdance\Util\getdirectoryPathRelativeToPluginFolder(__DIR__)
);

class DateUpdated extends \Breakdance\Elements\Element
{
    static function uiIcon()
    {
        return '<svg fill="currentColor" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><!--! Font Awesome Pro 6.2.0 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license (Commercial License) Copyright 2022 Fonticons, Inc. --><path d="M128 0c17.7 0 32 14.3 32 32V64H288V32c0-17.7 14.3-32 32-32s32 14.3 32 32V64h48c26.5 0 48 21.5 48 48v48H0V112C0 85.5 21.5 64 48 64H96V32c0-17.7 14.3-32 32-32zM0 192H448V464c0 26.5-21.5 48-48 48H48c-26.5 0-48-21.5-48-48V192zm80 64c-8.8 0-16 7.2-16 16v96c0 8.8 7.2 16 16 16h96c8.8 0 16-7.2 16-16V272c0-8.8-7.2-16-16-16H80z"/></svg>';
    }

    static function tag()
    {
        return 'div';
    }

    static function tagOptions()
    {
        return [];
    }

    static function tagControlPath()
    {
        return false;
    }

    static function name()
    {
        return 'Date Updated';
    }

    static function className()
    {
        return 'autogenerated-bce-dateupdated';
    }

    static function category()
    {
        return 'destiny_blog';
    }

    static function badge()
    {
        return false;
    }

    static function slug()
    {
        return get_class();
    }

    static function template()
    {
        return file_get_contents(__DIR__ . '/html.twig');
    }

    static function defaultCss()
    {
        return file_get_contents(__DIR__ . '/default.css');
    }

    static function defaultProperties()
    {
        return ['content' => ['date' => ['date_format' => 'first', 'before_text' => 'Last Updated: '], 'time' => ['include_time' => true, 'before_text' => 'at ', 'time_format' => 'twelve', 'custom' => null], 'delay' => ['testing' => false, 'show_after_hours_' => 24, 'show_straight_away' => false, 'show_after_minutes_' => 1440]], 'design' => ['container' => ['margin' => ['bottom' => ['number' => 20, 'unit' => 'px', 'style' => '20px']], 'width' => null], 'typograhpy' => ['typography' => null, 'text' => null, 'before_text' => null, 'date' => null, 'time' => null]]];
    }

    static function defaultChildren()
    {
        return false;
    }

    static function cssTemplate()
    {
        $template = file_get_contents(__DIR__ . '/css.twig');
        return $template;
    }

    static function designControls()
    {
        return [c(
        "container",
        "Container",
        [c(
        "spacing",
        "Spacing",
        [c(
        "padding",
        "Padding",
        [],
        ['type' => 'spacing_complex', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "margin",
        "Margin",
        [],
        ['type' => 'spacing_complex', 'layout' => 'vertical'],
        false,
        false,
        [],
      )],
        ['type' => 'section', 'layout' => 'inline', 'sectionOptions' => ['type' => 'popout']],
        false,
        false,
        [],
      )],
        ['type' => 'section'],
        false,
        false,
        [],
      ), c(
        "typograhpy",
        "Typograhpy",
        [getPresetSection(
      "EssentialElements\\typography",
      "Text",
      "text",
       ['type' => 'popout']
     ), getPresetSection(
      "EssentialElements\\typography",
      "Before Text",
      "before_text",
       ['type' => 'popout']
     ), getPresetSection(
      "EssentialElements\\typography",
      "Date",
      "date",
       ['type' => 'popout']
     ), getPresetSection(
      "EssentialElements\\typography",
      "Time",
      "time",
       ['type' => 'popout']
     )],
        ['type' => 'section'],
        false,
        false,
        [],
      )];
    }

    static function contentControls()
    {
        return [c(
        "date",
        "Date",
        [c(
        "date_format",
        "Date Format",
        [],
        ['type' => 'dropdown', 'layout' => 'vertical', 'items' => ['0' => ['value' => 'first', 'text' => 'April 1st, 2022 (F jS,Y)'], '1' => ['value' => 'second', 'text' => '2022-04-01 (Y-m-d)'], '2' => ['value' => 'third', 'text' => '04/01/2022 (m/d/y)'], '3' => ['value' => 'fourth', 'text' => '01/04/2022 (d/m/Y)'], '4' => ['text' => 'Custom', 'value' => 'custom']]],
        false,
        false,
        [],
      ), c(
        "before_text",
        "Before Text",
        [],
        ['type' => 'text', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "custom_date_format",
        "Custom Date Format",
        [],
        ['type' => 'text', 'layout' => 'vertical', 'condition' => ['path' => 'content.date.date_format', 'operand' => 'equals', 'value' => 'custom']],
        false,
        false,
        [],
      )],
        ['type' => 'section', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "time",
        "Time",
        [c(
        "include_time",
        "Include TIme",
        [],
        ['type' => 'toggle', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "time_format",
        "Time Format",
        [],
        ['type' => 'dropdown', 'layout' => 'vertical', 'condition' => ['path' => 'content.time.include_time', 'operand' => 'is set', 'value' => ''], 'items' => ['0' => ['value' => 'twelve', 'text' => '7:40 pm (g:i a)'], '1' => ['text' => '19:40 (H:i)', 'value' => 'twentyfour'], '2' => ['text' => 'Custom', 'value' => 'custom']]],
        false,
        false,
        [],
      ), c(
        "custom",
        "Custom",
        [],
        ['type' => 'text', 'layout' => 'vertical', 'condition' => ['path' => 'content.time.time_format', 'operand' => 'equals', 'value' => 'custom']],
        false,
        false,
        [],
      ), c(
        "before_text",
        "Before Text",
        [],
        ['type' => 'text', 'layout' => 'vertical', 'condition' => ['path' => 'content.time.include_time', 'operand' => 'is set', 'value' => '']],
        false,
        false,
        [],
      )],
        ['type' => 'section', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "delay",
        "Delay",
        [c(
        "show_immediately",
        "Show Immediately",
        [],
        ['type' => 'toggle', 'layout' => 'vertical'],
        false,
        false,
        [],
      ), c(
        "show_after_minutes_",
        "Show After (minutes)",
        [],
        ['type' => 'number', 'layout' => 'vertical', 'condition' => ['path' => 'content.delay.show_straight_away', 'operand' => 'is not set', 'value' => '']],
        false,
        false,
        [],
      ), c(
        "alert",
        "Alert",
        [],
        ['type' => 'alert_box', 'layout' => 'vertical', 'alertBoxOptions' => ['style' => 'default', 'content' => '<p>60 Minutes = 1 hour</p><p>1440 Minutes = 24 Hours</p>'], 'condition' => ['path' => 'content.delay.show_straight_away', 'operand' => 'is not set', 'value' => '']],
        false,
        false,
        [],
      )],
        ['type' => 'section', 'layout' => 'vertical'],
        false,
        false,
        [],
      )];
    }

    static function settingsControls()
    {
        return [];
    }

    static function dependencies()
    {
        return false;
    }

    static function settings()
    {
        return false;
    }

    static function addPanelRules()
    {
        return false;
    }

    static public function actions()
    {
        return false;
    }

    static function nestingRule()
    {
        return ["type" => "final",   ];
    }

    static function spacingBars()
    {
        return false;
    }

    static function attributes()
    {
        return false;
    }

    static function experimental()
    {
        return false;
    }

    static function order()
    {
        return 390;
    }

    static function dynamicPropertyPaths()
    {
        return ['0' => ['accepts' => 'string', 'path' => 'content.date.custom_date_format'], '1' => ['accepts' => 'string', 'path' => 'content.date.before_text'], '2' => ['accepts' => 'string', 'path' => 'content.time.custom'], '3' => ['accepts' => 'string', 'path' => 'content.time.before_text'], '4' => ['accepts' => 'string', 'path' => 'content.delay.show_after_minutes_']];
    }

    static function additionalClasses()
    {
        return false;
    }

    static function projectManagement()
    {
        return false;
    }

    static function propertyPathsToWhitelistInFlatProps()
    {
        return false;
    }

    static function propertyPathsToSsrElementWhenValueChanges()
    {
        return false;
    }
}
